;/******************************/;
;/* Example For : JRHC08JL3 V1 */;
;/* Controller  : 68HC908JL3   */;
;/* Assembler   : CASM08Z.EXE  */;
;/* Demo For Unbuffer O/P Test */;
;/* Use CH0 Generate O/P Signal*/;
;/* Signal Output = TCH0(PTD4) */;
;/******************************/;
;
;/*************************/;
;/* Register HC08 Equates */;
;/*************************/;
;
PORTA       EQU     $0000                   ; Port-A Data Register
PORTB       EQU     $0001                   ; Port-B Data Register
PORTD       EQU     $0003                   ; Port-D Data Regsiter
DDRA        EQU     $0004                   ; Port-A Direction Register
DDRB        EQU     $0005                   ; Port-B Direction Register
DDRD        EQU     $0007                   ; Port-D Direction Register
PDCR        EQU     $000A                   ; Port-D Control Register
PTAPUE      EQU     $000D                   ; Port-A Pull-Up Enable
KBSCR       EQU     $001A                   ; Keyboard Status Control
KBIER       EQU     $001B                   ; Keyboard Interrupt Enable
INTSCR      EQU     $001D                   ; IRQ Status Control
CONFIG2     EQU     $001E                   ; Config Register2
CONFIG1     EQU     $001F                   ; Config Register1
TSC         EQU     $0020                   ; TIM Status & Control
TCNTH       EQU     $0021                   ; TIM Counter High
TCNTL       EQU     $0022                   ; TIM Counter Low
TMODH       EQU     $0023                   ; TIM Counter Modulo High
TMODL       EQU     $0024                   ; TIM Counter Modulo Low
TSC0        EQU     $0025                   ; TIM CH0 Status & Control
TCH0H       EQU     $0026                   ; TIM CH0 High
TCH0L       EQU     $0027                   ; TIM CH0 Low
TSC1        EQU     $0028                   ; TIM CH1 Status & Control
TCH1H       EQU     $0029                   ; TIM CH1 High
TCH1L       EQU     $002A                   ; TIM CH1 Low
ADSCR       EQU     $003C                   ; ADC Status & Control
ADR         EQU     $003D                   ; ADC Data Read
ADICLK      EQU     $003E                   ; ADC Input Clock
BSR         EQU     $FE00                   ; Break Status Register
RSR         EQU     $FE01                   ; Reset Status Register
BFCR        EQU     $FE03                   ; Break Flag Control
INT1        EQU     $FE04                   ; Interrupt Status1
INT2        EQU     $FE05                   ; Interrupt Status2
INT3        EQU     $FE06                   ; Interrupt Status3
FLCR        EQU     $FE08                   ; Flash Control Register
FLBPR       EQU     $FE09                   ; Flash Block Protect
BRKH        EQU     $FE0C                   ; Break Address High
BRKL        EQU     $FE0D                   ; Break Address Low
BRKSCR      EQU     $FE0E                   ; Break Status & Control
COPCTL      EQU     $FFFF                   ; Reset COP
;/* End Equate I/O Register of HC08 */;
;
BIT0        EQU     $00                     ; Bit Addressible
BIT1        EQU     $01
BIT2        EQU     $02
BIT3        EQU     $03
BIT4        EQU     $04
BIT5        EQU     $05
BIT6        EQU     $06
BIT7        EQU     $07
;
PERIOD_HI   EQU     $1F                     ; Period = 1mS (8000 x (1/8MHz)
PERIOD_LO   EQU     $40
$BASE       10T                             ; Defualt Number to Decimal

            ORG     $EC00                   ; Start Main (68HC908JL3)
            ;
RESET:      BSET    0,CONFIG1               ; Disable COP Watch-Dog
            LDA     #%00000000              ; X0XXXXXX (Clear TOIE)
            ORA     #%00110000              ; XX11XXXX (Stop & Reset Timer Count)
            ORA     #%00000000              ; XXXXX000 (Prescale = 1)
            STA     TSC                     ; Clear TOIE + Stop & Reset + Prescale:1
            ;
            LDA     #%01000000              ; X1XXXXXX (CH0IE = 1: Enable Interrupt)
            ORA     #%00010000              ; XX01XXXX (Mode Select = Unbuffer O/P)
            ORA     #%00000100              ; XXXX01XX (Toggle Output on Compare)
            ORA     #%00000000              ; XXXXXX0X (Not Toggle on Overflow)
            STA     TSC0
            ;
            MOV     #PERIOD_HI,TCH0H        ; Define Period of O/P = 1mS
            MOV     #PERIOD_LO,TCH0L
            ;
            CLI                             ; Enable CPU Interrupt
            BCLR    BIT5,TSC                ; Enable & Strat Timer(TSTOP)
            BRA     $                       ; Loop Here For Wait Interrupt

;/*****************/;
;/* OC0 Interrupt */;
;/*****************/;
;
OC0_SRV:    PSHH                            ; Save Register
            LDA     TSC0                    ; Read CH0 Status
            BCLR    BIT7,TSC0               ; Clear CH0F
            BSET    BIT4,TSC                ; Reset Timer Count
            PULH                            ; Restore Register
            RTI


            ;/***************/;
            ;/* User Vector */;
            ;/***************/;
            ;
            ORG     $FFF6                   ; TIM CH0 Vector
            DW      OC0_SRV
            ;
            ORG     $FFFE                   ; Reset Vector
            DW      RESET

            END

